﻿package  {
	import flash.display.BitmapData;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.utils.getTimer;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.objects.primitives.Sphere;
	import org.papervision3d.view.BasicView;

	/**
	 * 3D View
	 */
	public class World extends BasicView{
		private var sphere1:Sphere;
		private var sphere2:Sphere;
		/**
		 * コンストラクタ
		 */
		public function World() {
			//初期化
			init();
			//フレームレート表示
			showFPS();
		}

		public function init() {
			//ライブラリにリンケージしてあるビットマップデータ
			var bmd = new TextureBitmapData(256,256);
			//------------------------
			//球体1のマテリアル(スムージングなし)
			var material1:BitmapMaterial = new BitmapMaterial(bmd);
			//球体1
			sphere1 = new Sphere(material1, 100,10,8);
			sphere1.x = -110;
			scene.addChild(sphere1);
			
			//------------------------
			//球体2のマテリアル(スムージングあり)
			var material2:BitmapMaterial = new BitmapMaterial(bmd);
			//スムージングON
			material2.smooth = true;
			//球体2
			sphere2 = new Sphere(material2, 100,10,8);
			sphere2.x = 110;
			scene.addChild(sphere2);

			//------------------------
			//カメラ位置調整
			camera.fov = 30;
			camera.y = 0;
			camera.z = -800;
			camera.target = null;
			//描画開始
			startRendering();

		}

		override protected function onRenderTick(event:Event = null):void {
			//表示用平面を回転させる
			sphere1.rotationY += 1;
			sphere2.rotationY += 1;

			super.onRenderTick();
		}
		
		//---------------------------
		//以下、フレームレート計算用
		private	var fps_text:TextField = new TextField();
		private var update_time = 500;
		private	var draw_count = 0;
		private	var old_timer = getTimer();
		private function showFPS():void{
			fps_text.background = true;
			fps_text.selectable = false;
			fps_text.width = 70;
			fps_text.height = 18;
			this.addChild (fps_text);
			this.addEventListener(Event.ENTER_FRAME , onFPS);
		}
		private function onFPS(e:Event):void{
			draw_count += 1;
			if (getTimer()-old_timer >= update_time) {
				var fps = draw_count * 1000 / (getTimer() - old_timer);
				fps = Math.floor(fps * 10) / 10;  
				fps_text.text ="FPS:"+ fps + ' / ' + fps_text.stage.frameRate;
				old_timer = getTimer();
				draw_count = 0;
			}
		}
	}
}
